#<profile4xi profile = "31"/>
#<program4xi program = "walk2deldup4app.py">
#<abstract4xi abstract = "walks through HTML files of spefied directory and its subdirectories deleting dublicates as required"/>
#<refer4xi reference = "Studio4Xi"/>
#<note4xi note = "test first with one folder, edit version4xi.py, search text(s) must be unique"/>
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; ACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'walk2deldup4app' ]
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os,sys,string
import time4xi
#"
#/>

# -------------------------------------------------------------------------------------------------
# Studio4Xi imports                               
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
import version4xi
from version4xi import VersionKB4Xi
from version4xi import ROOT4XI 
#"
#/>
# -------------------------------------------------------------------------------------------------
# Multiprocessing4xi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from actor2a4xi import Actor2a4Xi                                                                                  
from actor2b4xi import Actor2b4Xi                                                                                   
from actor2c4xi import Actor2c4Xi
from actor2d4xi import Actor2d4Xi
from actor2e4xi import Actor2e4Xi
from actor2f4xi import Actor2f4Xi
from actor2g4xi import Actor2g4Xi
from actor2h4xi import Actor2h4Xi
from actor2i4xi import Actor2i4Xi
from actor2j4xi import Actor2j4Xi
from actor2k4xi import Actor2k4Xi
from actor2l4xi import Actor2l4Xi
from actor2m4xi import Actor2m4Xi
from actor2n4xi import Actor2n4Xi
from actor2o4xi import Actor2o4Xi
from actor2p4xi import Actor2p4Xi
from actor2q4xi import Actor2q4Xi
from actor2r4xi import Actor2r4Xi
from actor2s4xi import Actor2s4Xi
from actor2t4xi import Actor2t4Xi
from actor2u4xi import Actor2u4Xi
from actor2v4xi import Actor2v4Xi
from actor2w4xi import Actor2w4Xi
from actor2x4xi import Actor2x4Xi
from actor2y4xi import Actor2y4Xi
from actor2z4xi import Actor2z4Xi
from actor2_4xi import Actor2_4Xi
from pickle4xi import pickle4xi                                                                                   
from pickle2a4xi import Pickle2a4Xi
from pickle2b4xi import Pickle2b4Xi
from pickle2c4xi import Pickle2c4Xi
from pickle2d4xi import Pickle2d4Xi
from pickle2e4xi import Pickle2e4Xi
from pickle2f4xi import Pickle2f4Xi
from pickle2g4xi import Pickle2g4Xi
from pickle2h4xi import Pickle2h4Xi
from pickle2i4xi import Pickle2i4Xi
from pickle2j4xi import Pickle2j4Xi
from pickle2k4xi import Pickle2k4Xi
from pickle2l4xi import Pickle2l4Xi
from pickle2m4xi import Pickle2m4Xi
from pickle2n4xi import Pickle2n4Xi
from pickle2o4xi import Pickle2o4Xi
from pickle2p4xi import Pickle2p4Xi
from pickle2q4xi import Pickle2q4Xi
from pickle2r4xi import Pickle2r4Xi
from pickle2s4xi import Pickle2s4Xi
from pickle2t4xi import Pickle2t4Xi
from pickle2u4xi import Pickle2u4Xi
from pickle2v4xi import Pickle2v4Xi
from pickle2w4xi import Pickle2w4Xi
from pickle2x4xi import Pickle2x4Xi
from pickle2y4xi import Pickle2y4Xi
from pickle2z4xi import Pickle2z4Xi
from pickle2_4xi import Pickle2_4Xi 
from pipe4xi import Pipe4Xi   
from print4xi import print4xi
from print4xi import Print4Xi      # from lutiprocessing4xi 
from process4xi import Process4Xi
from queue4xi import Queue4Xi
from time4xi import time4xi

from xml_trace_sense4xi import xml_trace_sense4xi                                                                   
from xml_trace_reason4xi import xml_trace_reason4xi
from xml_trace_ace4xi import xml_trace_ace4xi 
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
import _multiprocessing
#"
#/>


# -------------------------------------------------------------------------------------------------
# Globals                            
# -------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global ack2debug
global count2skipped
global count2replaced
global count2total
global file2output

global header2trace

global kb2add
global kb2append
global kb2pass
global kb2replace
global kb2search
global kb2stat                             

global key2add
global key2append
global key2pass
global key2replace
global key2search
global key2stat  

global keys2add
global keys2append
global keys2pass
global keys2replace
global keys2search
global keys2stat  

global name2create

global path2temp4source  
global path2read4xi                          # path for input source targets
global path2write4xi                         # path for output source targets
global PickleKB4Xi
global previoustag
global profile2fetch                         # extension for files

global t2xi 
global trace_object_count
#"
#"/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = True    # turn on/off 
file2output = None
count2skipped = 0
count2replaced = 0
count2total = 0
key2stat = 0

header2trace = "<h3><b>&Psi;</b> Ocean, Desert, Tepui, Environment</h3>"
 
kb2add      = {}  
kb2append   = {}  
kb2pass     = {}  
kb2replace  = {}  
kb2search   = {}
kb2stat     = {}

previoustag = "<dummy-tag>"  


# ================================================================================================
# KB2APPEND - LINES TO BE WRITTEN BEFORE THE ONE FOUND 
# ================================================================================================

# --------
# RUN1     - NONE
# --------
kb2append    = {}

# ==============================================================================================
# KB2SEARCH 
# ==============================================================================================

# --------
# RUN1 -  STRING TO BE SEARCHED
# --------
kb2search [1]='<tr>'


# ===============================================================================================================
# KB2REPLACE - [0] KEPT AS IT WAS - WHEREAS [1] ADDED  AS FOLLOWS
# ===============================================================================================================

# --------
# RUN1 -  # only one to replace in input files
# --------
key2replace = 1                      
kb2replace [key2replace] = {
0: '<tr>'
}


# ==============================================================================================
# KB2ADD - set according to the number of lines to be added from kb2replace after the replaced one
# note: key2add goes up to max2range - 1; min key2add = 2 normally; 1 = None 
#       either use walk2replace4app.py just to replace or add an empty line
# ==============================================================================================

# --------
# RUN1
# --------
max2range = 1  

for key2add in range(1, max2range):
    kb2add [key2add] = key2add


# ==============================================================================================
# KB2PASS - set according to the number of lines to be passed based 
#           after all lines from kb2replace have been written 
#           1 = None, 2 = 1 ...
#           provided the line contains the same tag as the previous line which is bug
# ==============================================================================================

# --------
# RUN1
# --------
max2pass = 1 

for key2pass in range(1, max2pass): # key2pass goes up to max2pass - 1
    kb2pass [key2pass] = key2pass
    
    
# -------------------------------------------------------------------------------------------------
#
# -------------------------------------------------------------------------------------------------
keys2add     = kb2add.keys()        
keys2append  = kb2append.keys()
keys2pass    = kb2pass.keys()
keys2search  = kb2search.keys()
keys2stat    = kb2stat.keys()
keys2replace = kb2replace.keys()

    
# -------------------------------------------------------------------------------------------------
#
# -------------------------------------------------------------------------------------------------
path2write4xi = None

path2read4xi  = VersionKB4Xi['input2deldup4app']   # defines input folder to be walked with all its subfolders
path2write4xi = VersionKB4Xi['output2deldup4app']  # defines output folder for savings 
    
# -------------------------------------------------------------------------------------------------
#
PickleKB4Xi = {
       'a': Pickle2a4Xi,
       'b': Pickle2b4Xi,
       'c': Pickle2c4Xi,
       'd': Pickle2d4Xi,
       'e': Pickle2e4Xi,
       'f': Pickle2f4Xi,
       'g': Pickle2g4Xi,
       'h': Pickle2h4Xi,
       'i': Pickle2i4Xi,
       'j': Pickle2j4Xi,
       'k': Pickle2k4Xi,
       'l': Pickle2l4Xi,
       'm': Pickle2m4Xi,
       'n': Pickle2n4Xi,
       'o': Pickle2o4Xi,
       'p': Pickle2p4Xi,
       'q': Pickle2q4Xi,
       'r': Pickle2r4Xi,
       's': Pickle2s4Xi,
       't': Pickle2t4Xi,
       'u': Pickle2u4Xi,
       'v': Pickle2v4Xi,
       'w': Pickle2w4Xi,
       'x': Pickle2x4Xi,
       'y': Pickle2y4Xi,
       'z': Pickle2z4Xi,
       '_': Pickle2_4Xi} 

#"
#"/>

# -------------------------------------------------------------------------------------------------
#<define4xi definition = "
profile2fetch = '.html'                      # object types to be fetched
                                             # '.txt'= text '.py'=Python, '.cpp'=C++, '.hpp'=headers, '.c'=C, 
                                             # '.html', 'xml'

#"
#/>


# ----------------------------------------------------------------------------------------------------------
#<function4xi function = "set2trace4replace" usage = "setting trace using definitions in pickle4xi functions !
#">                      
# ----------------------------------------------------------------------------------------------------------    
def set2trace4replace():
    global ack2debug
    global t2xi 
    global trace_object_count
    global PickleKB4Xi

    if ack2debug is True:
        print("(Step 1A/33) OF SET2TRACE4REPLACE - STARTING SETTING TRACE BASED ON TRACE SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
        print("(Step 1B/33) OF SET2TRACE4REPLACE - USING T2XI: ", t2xi)
        # <print4xi.Print4Xi object at 0x0000000003715080>    
    
    # ---------------------------------------------------------------------------------------------
    # A, B .... _ 
    # ---------------------------------------------------------------------------------------------
    keys2pickledb = sorted(PickleKB4Xi.keys())
    for key2pickledb in keys2pickledb:
        # -----------------------------------------------------------------------------------------    
        # LETTERS
        # -----------------------------------------------------------------------------------------     
        # print('=' *33)
        # print("STARTING LETTER : ", key2pickledb)
        # print('=' *33)
   
        dictionary2pickle = PickleKB4Xi[key2pickledb]        
        # print("STARTING DICTIONARY: ", dictionary2pickle)
        # print('~' *33) 
        # 
        keys2dictionary = sorted(dictionary2pickle.keys())
    
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        for key2dictionary in keys2dictionary:
            # -------------------------------------------------------------------------------------    
            # DICTIONARY
            # -------------------------------------------------------------------------------------     
            # print('~' *33)        
            object2pickle = key2dictionary        
            # print("STARTING OBJECT: ", object2pickle)
            # print('~' *33)         
            # pickle4xi(object2pickle)
            # print('~' *33)                  
            # print("PICKLED object: ", object2pickle)
            # PICKLED object:  _C4Xi, 
            # ---------------------------------------------------------------------------------    
            # Mark those with NACK4XI to be traced !
            # ---------------------------------------------------------------------------------     
            if dictionary2pickle[key2dictionary] == 'NACK4XI':
                set_param2xi = True     
                key_param = object2pickle     
                t2xi.set_print_permission(key_param, set_param2xi)
                # print("(Step 2A/33) OF SET2TRACE4REPLACE - MARKED TO BE TRACED OBJECT: ", object2pickle)                                
                # APU2Buffer4Xi; APU2CommandQueue4Xi ... finish2commandqueue4bpu; finish2commandqueue4apu ...
            else:
                pass  
            # ---------------------------------------------------------------------------------    
            # END OF DICTIONARY
            # ---------------------------------------------------------------------------------     
        # -----------------------------------------------------------------------------------------    
        # END OF LETTERS
        # -----------------------------------------------------------------------------------------     
        # print('~' *33)        
        # print("COMPLETED  DICTIONARY: ", dictionary2pickle)
        # print('~' *33) 
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------     
    # print('=' *33)
    # print("COMPLETED LETTER : ", key2pickledb)
    # print('=' *33)
    # ---------------------------------------------------------------------------------------------
    # 
    # ---------------------------------------------------------------------------------------------
    if ack2debug is True:
        print('=' *33)
        print("(Step 33/33) OF SET2TRACE4REPLACE - COMPLETED SETTING TRACE BASED ON NACK4XI/ACK4XI SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
        print('=' *33)
#</function4xi> 

       
# -------------------------------------------------------------------------------------------------
#<function4xi function = "deny2trace4replace" usage = "
#   deny trace using pickle4xi functions !
#">                      
# -------------------------------------------------------------------------------------------------    
def deny2trace4replace():
    global ack2debug
    global t2xi 
    global trace_object_count
    global PickleKB4Xi

    if ack2debug is True:
        print("(Step 01A/33) of DENY2TRACE4REPLACE: STARTING DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
        print("(Step 01B/33) OF DENY2TRACE4REPLACE - USING T2XI: ", t2xi)
        # <print4xi.Print4Xi object at 0x0000000003715080>
    
    # ---------------------------------------------------------------------------------------------
    # A, B .... _ 
    # ---------------------------------------------------------------------------------------------
    keys2pickledb = sorted(PickleKB4Xi.keys())
    for key2pickledb in keys2pickledb:
        # -----------------------------------------------------------------------------------------    
        # LETTERS
        # -----------------------------------------------------------------------------------------     
        # print("(Step 02A/33) OF DENY2TRACE4REPLACE - STARTING LETTER : ", key2pickledb)
        dictionary2pickle = PickleKB4Xi[key2pickledb]        
        # print("(Step 02B/33) OF DENY2TRACE4REPLACE - STARTING DICTIONARY: ", dictionary2pickle)
        keys2dictionary = sorted(dictionary2pickle.keys())
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        for key2dictionary in keys2dictionary:
   
            # -------------------------------------------------------------------------------------    
            # DICTIONARY
   
            object2pickle = key2dictionary        
            # print("(Step 02C/33) OF DENY2TRACE4REPLACE - STARTING OBJECT: ", object2pickle)
            # pickle4xi(object2pickle)        
            # print("STEP: PICKLED object: ", object2pickle)
            # PICKLED object:  _C4Xi, 
            
            # ---------------------------------------------------------------------------------    
            # ACK4XI = tested .i.e. NOT to be traced! 
            # ---------------------------------------------------------------------------------     
            set_param2xi = 'ACK4XI'     
            key_param = object2pickle     
            t2xi.set_print_permission(key_param, set_param2xi)
            # print("(Step 02D/33) OF DENY2TRACE4REPLACE - MARKED TESTED AND NOT to be traced: ", object2pickle)
            
            dictionary2pickle[key2dictionary] = 'ACK4XI' 
                    
        
            # ---------------------------------------------------------------------------------    
            # END OF DICTIONARY
            # ---------------------------------------------------------------------------------     
            # print('~' *33)              
            # print("(Step 02Z/33) OF DENY2TRACE4REPLACE *** FAILED - ERROR IN PICKLING OBJECT - NOT TO BE TRACED: ", object2pickle)
            # print('~' *33) 
        # -----------------------------------------------------------------------------------------    
        # END OF LETTERS
        # -----------------------------------------------------------------------------------------     
        # print("(Step 02E/33) OF DENY2TRACE4REPLACE - COMPLETED  DICTIONARY: ", dictionary2pickle)
        # 
        
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------     
    # print("(Step 02F/33) OF DENY2TRACE4REPLACE - COMPLETED LETTER : ", key2pickledb)
    # _, a ... z            
    if ack2debug is True:
        print("(Step 033/33) OF SET2TRACE4REPLACE - COMPLETED DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "tailor2trace4xi" usage = "
#   tailors trace 
#">                      
# -------------------------------------------------------------------------------------------------    
def tailor2trace4xi():
    global ack2debug
    global trace_object_count
    global PickleKB4Xi 
    global t2xi
 
    if ack2debug is True:
        print("(Step 001A/33) OF TAILOR2TRACE4REPLACE - USING T2XI: ", t2xi)
        # <print4xi.Print4Xi object at 0x0000000003715080> 
                         
    # ---------------------------------------------------------------------------------------------
    # Settings to tailor trace
    # ---------------------------------------------------------------------------------------------
    #<set4xi setting = "
    KB4Tailoring = {
         # 'Pipe4Xi': 'NACK4TRACE',
         # 'Queue4Xi': 'NACK4TRACE',         
         # 'Process4Xi': 'NACK4TRACE',
         # 'walk2deldup4app': 'NACK4TRACE' # turns on/off
        }                             
                
    default3trace = 'NACK4TRACE' # we do NOT want trace if object is not found! 
    #"/>
    
    # ---------------------------------------------------------------------------------------------
    # PROCESS KB4Tailoring
    # ---------------------------------------------------------------------------------------------
    keys2tailor = sorted(KB4Tailoring.keys())
    for key2tailor in keys2tailor:
        # ---------------------------------------------------------------------------------    
        # NACK4XI = NOT TESTED .I.E. TO BE TRACED! 
        # ---------------------------------------------------------------------------------     
        set_param2xi = 'NACK4XI'     
        key_param = key2tailor    
        t2xi.set_print_permission(key_param, set_param2xi)
        if ack2debug is True:
            print("(Step 002A/33) OF TAILOR_TRACE4XI - MARKED TO BE TESTED: ", key2tailor)
            # Pipe4Xi, Process4Xi, Queue4Xi, walk2deldup4app

    # -----------------------------------------------------------------------------------------    
    # EOF KEYS
    # -----------------------------------------------------------------------------------------     
    if ack2debug is True:
        print("(Step 0033/33) OF TAILOR_TRACE4XI - COMPLETED  TAILORING: ", time4xi())
        #

    
     
#</function4xi>             
    
# -------------------------------------------------------------------------------------------------
#<function4xi function = "print-trace4xi" usage = "
# print XML trace
#"> 
# -------------------------------------------------------------------------------------------------    
def print_trace4xi(t2xi):
    
    class2print  = "walk2deldup4app"
    method2print = "walk2deldup4app" 
        
    message2print = "{passed" + "; t2xi-passed-to-print-trace4xi: " + str(t2xi) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)   
    #    

    # -------------------------------------------------------------------------------------------------
    # SENSE                        
    # -------------------------------------------------------------------------------------------------  
    context2sense = {
     'file_path4xi': '..//..//..//..//web//xml//sense-walk2deldup4app.xml',
     'name_space4xi': '   xmlns="https://www.yourdragonxi.org/sw4xi/python33/xml/walk2deldup4app.owl#"\n',
     'xml_base4xi': '   xml:base="https://www.yourdragonxi.org/sw4xi/python33/xml/walk2deldup4app.owl#"\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Sensing ofStudio4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Classes, methods and messages with context.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="yourDragon4Xi#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Sensing walk2deldup4app.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="sensed#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">walk2deldup4app sensed.</rdfs:comment>\n',
     'debug4xi': True}
      
    xml_trace_sense4xi(t2xi, context2sense)

    # -------------------------------------------------------------------------------------------------
    # REASON                         
    # -------------------------------------------------------------------------------------------------  
        
    context2reason = {
     'file_path4xi': '..//..//..//..//web//xml//reason-walk2deldup4app.xml',
     'name_space4xi': '   xmlns="https://www.yourdragonxi.org/sw4xi/python33/xml/walk2deldup4app.owl#"\n',
     'xml_base4xi': '   xml:base="https://www.yourdragonxi.org/sw4xi/python33/xml/walk2deldup4app.owl#"\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Reasoning of Studio4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Operations</rdfs:comment>\n',
     'operation_comment4xi': '      <rdfs:comment xml:lang="en">Operations for walk2deldup4app.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="reasoned#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Operations with context.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="reason#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">reason</rdfs:comment>\n',
     'debug4xi': True}
       
    xml_trace_reason4xi(t2xi, context2reason)

    # -------------------------------------------------------------------------------------------------
    # ACE                         
    # -------------------------------------------------------------------------------------------------  
       
    context2ace = {
     'file_path4xi': '..//..//..//..//web//xml//ace-walk2deldup4app.xml',
     'name_space4xi': '   xmlns="https://www.yourdragonxi.org/sw4xi/python33/xml/walk2deldup4app.owl#"\n',
     'xml_base4xi': '   xml:base="https://www.yourdragonxi.org/sw4xi/python33/xml/walk2deldup4app.owl#"\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Acing of Studio4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values for walk2deldup4app.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="ACE4Xi#0000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values of walk2deldup4app.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="ace#0000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">000000</rdfs:comment>\n',
     'debug4xi': True}   
    
    xml_trace_ace4xi(t2xi, context2ace)


    # -------------------------------------------------------------------------------------------------
    # end of print_trace4xi                        
    # -------------------------------------------------------------------------------------------------  
#</function4xi>
       
# -------------------------------------------------------------------------------------------------
#<function4xi function = "walk2deldup4app" usage = "
#   replaces defined targets from dragon4xi folders
#"> 
# -------------------------------------------------------------------------------------------------
def walk2deldup4app(target2explore):
    global ack2debug
    global count2skipped
    global count2replaced
    global count2total
    
    global header2trace
    
    global kb2add
    global kb2append
    global kb2pass
    global kb2replace
    global kb2search
    global kb2stat                             

    global key2add
    global key2append
    global key2pass
    global key2replace
    global key2search
    global key2stat 

    global keys2add
    global keys2append
    global keys2pass
    global keys2replace
    global keys2search
    global keys2stat 
     
    global name2create   
    global path2read4xi                            # path for input source targets
    global path2write4xi                           # path for output source targets
    global previoustag
    global profile2fetch                           # extension for files

    global t2xi
    global trace_object_count    
    
    class2print  = "walk2deldup4app"
    method2print = "walk2deldup4app" 
 
    message2print = "{(Step 0A/33) using" + "; t2xi-using-by-walk2deldup4app: " + str(t2xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)         
    # <print4xi.Print4Xi object at 0x0000000003715080>
    
    message2print = "{(Step 1/8) got" + "; target2explore-got-by-walk2deldup4app: " + str(target2explore)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print) 
    # 
               
    # ---------------------------------------------------------------------------------------------
    # SPLIT TARGET NAME WITH PATH AND EXTENSION TO TWO PIECES
    # ---------------------------------------------------------------------------------------------    
    name2target=os.path.splitext(target2explore)
    
    path2input = None    
    if name2target[1] == profile2fetch:
        # html
                  
        # -----------------------------------------------------------------------------------------
        # (Step 1/33) OF WALK2DELDUP4APP - TARGET ACCORDING TO PROFILE
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 1A/33) analyzing" + "; target2explore-analyzing-by-walk2deldup4app: " + str(target2explore) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)      
        # 
        
        # -----------------------------------------------------------------------------------------
        # (Step 2/33) OF WALK2DELDUP4APP - INPUT FILE PATH 
        # -----------------------------------------------------------------------------------------
        path2input = name2target[0] + profile2fetch 
        message2print = "{(Step 2A/33) set" + "; path2input-set-by-walk2deldup4app to: " + str(path2input)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)          
        # 

        # -----------------------------------------------------------------------------------------
        # (Step 3/33) OF WALK2DELDUP4APP - OPEN INPUT FILE
        # -----------------------------------------------------------------------------------------
        file2input = open(path2input,'r')
        message2print = "{(Step 3A/33) opened" + "; file2input-opened-by-walk2deldup4app: " + str(file2input) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)     
        # 
         
        # -----------------------------------------------------------------------------------------
        # (Step 3/33) OF WALK2DELDUP4APP - OUTPUT FILE NAME 
        # -----------------------------------------------------------------------------------------
        string2skip = '/'
        name2create = path2input
        max2try = 33
        count2try = 0
        while 1:
            index2skip = str.find(name2create,string2skip)
            count2try = count2try + 1
            if (index2skip == -1) or (count2try > max2try):
                break
            else:
                name2create = name2create[index2skip+1:]
                
        message2print = "{(Step 3B/33) set" + "; name2create to: " + str(name2create) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
                
        # -----------------------------------------------------------------------------------------
        # (Step 4/33) OF WALK2DELDUP4APP - OPEN OUTPUT FILE
        # -----------------------------------------------------------------------------------------
        path2output = path2write4xi + name2create
        
        message2print = "{(Step 4A/33) set" + "; path2output-set-by-walk2deldup4app to: " + str(path2output) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)     
        #        
        
        file2output = open(path2output,'w') 
        message2print = "{(Step 4B/33) opened" + "; file2output-opened-by-walk2deldup4app: " + str(file2output) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)     
        #  
        previoustag = "<dummy-tag>"
        while 1:
            # -------------------------------------------------------------------------------------
            # (Step 5/33) OF WALK2DELDUP4APP - PROCESS FILE
            # -------------------------------------------------------------------------------------             
            line2process = file2input.readline()  
            if not line2process:
                # ---------------------------------------------------------------------------------
                # (Step 5/33) OF WALK2DELDUP4APP - ALL LINES READ, FINISH
                # ---------------------------------------------------------------------------------             
                break                                               
            else:
                index2trace = str.find(line2process,header2trace)
                if (index2trace == -1):
                    pass
                else:
                    message2print = "{(Step 5A/33) got" + "; line2process-got-by-walk2deldup4app: " + str(line2process) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)
                    # <h3><b>&Psi;</b> Ocean, Desert, Tepui, Environment</h3>
                    # ...
                    
                # ---------------------------------------------------------------------------------
                # (Step 7/33) OF WALK2DELDUP4APP - EXAMINE AND IF NEEDED, PROCESS LINE 
                # ---------------------------------------------------------------------------------
                line2write = line2process
                first2tell = True
                ack2replace = False
                # 
                for key2search in keys2search:
                    # -----------------------------------------------------------------------------
                    # check all strings to be replaced
                    # ----------------------------------------------------------------------------- 
                    string2search = kb2search[key2search]
                    len2search = len(string2search)
                    
                    string2update = kb2replace[key2search] [0]
                    len2update = len(string2update)
                    
                    difference2len = len2update - len2search
                        
                    index2replace = str.find(line2write,string2search)
                    if (index2replace == -1):
                        previoustag = line2write
                        message2print = "{(Step 7A/33) set" + "; previoustag-set-by-walk2deldup4app to: " + str(previoustag) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        # ...
                        # <b>&Delta;</b> angelfalls 
                        # ...
                        # <b>&raquo;</b><a href="https://www.angelfalls.dev" target="_blank">dev</a>
                        # </td>
                        # </tr>
                        # ...
                        # <b>&Delta;</b> antarcticocean
                    else:
                        ack2replace = True
                        if first2tell is True: 
                            message2print = "{(Step 7B/33) got" + "; line2process-got-by-walk2deldup4app: " + str(line2process) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)
                            # ...
                            # <tr>
                            # <tr> <-- double to be handled

                            key2replace = key2search
                            first2tell = False
                              
                        message2print = "{(Step 7C/33) got" + "; string2search-got-by-walk2deldup4app: " + str(string2search) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        # <tr>
                        # <tr>
                        
                        message2print = "{(Step 7D/33) got" + "; previoustag-got-by-walk2deldup4app: " + str(previoustag) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        # </tr>
                        # <tr>
                        # 
                        message2print = "{(Step 7E/33) got" + "; string2update-got-by-walk2deldup4app: " + str(string2update) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        # <tr>
                        # <tr>
                        # 
                        message2print = "{(Step 7F/33) set" + "; index2replace-set-by-walk2deldup4app to: " + str(index2replace) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        # 
                        
                        message2print = "{(Step 7G/33) got" + "; begin2write-got-by-walk2deldup4app: " + str(line2write[0:index2replace]) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        #
                        
                                               
                        begin2write = line2write[0:index2replace] + string2update
                        
                        message2print = "{(Step 7H/33) set" + "; begin2write-set-by-walk2deldup4app to: " + str(begin2write) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        # 
                        
                        
                        index2next = index2replace + len2search                      
                        message2print = "{(Step 7I/33) set" + "; index2next-set-by-walk2deldup4app to: " + str(index2next) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        # 
                        
                        line2write = begin2write + line2write[index2next:]
                        
                        message2print = "{(Step 7J/33) set" + "; line2write-set-by-walk2deldup4app to: " + str(line2write) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        # <tr>
                        # <tr> <-- should not write although processed in vain
                        # 
                        
                          
                # ---------------------------------------------------------------------------------
                # (Step 29/33) OF WALK2DELDUP4APP - WRITE PROCESSED LINE
                # ---------------------------------------------------------------------------------                           
                if previoustag == string2search:
                    ack2replace = False
                    message2print = "{(Step 7K/33) set" + "; ack2replace-set-by-walk2deldup4app to: " + str(ack2replace) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)
                    # False
                    
                    key2stat = key2stat + 1
                    kb2stat [key2stat] = path2input
                    
                if ack2replace is True:
                    message2print = "{(Step 7L/33) got" + "; line2write-got-by-walk2deldup4app: " + str(line2write) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)
                    # <tr>
                    
                    # ---------------------------------------------------------------------------------
                    # WRITE FIRST LINES FROM KB2APPEND (IF ANY) 
                    # ---------------------------------------------------------------------------------
                    for key2append in keys2append:
                        if key2append > 0:
                            line2append = kb2append[key2append]
                            message2print = "{(Step 7M/33) got" + "; line2append-got-by-walk2deldup4app: " + str(line2append) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)
                            # 
                            file2output.write(append)                    

                    # ---------------------------------------------------------------------------------
                    # WRITE THE LINE REPLACED (MAY HAVE THE SAME CONTENT) 
                    # ---------------------------------------------------------------------------------                                        
                    file2output.write(line2write)
                    message2print = "{(Step 7N/33) wrote" + "; line2write-wrote-by-walk2deldup4app: " + str(line2write) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)
                    # <tr>
                        
                    previoustag = string2search
                    message2print = "{(Step 7O/33) set" + "; previoustag-set-by-walk2deldup4app to: " + str(previoustag) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)
                    # <tr>    
                    
                    # ---------------------------------------------------------------------------------
                    # WRITE LINES FROM kb2replace USING key2add  JATKAA
                    # ---------------------------------------------------------------------------------    
                    message2print = "{(Step 7P/33) got" + "; key2replace-got-by-walk2deldup4app: " + str(key2replace) + "; time: " + time4xi() + "}"
                    # 1
                    for key2add in keys2add:
                        if key2add > 0:
                            line2write = kb2replace [key2replace] [key2add]
                            message2print = "{(Step 7Q/33) got" + "; key2add-got-by-walk2deldup4app: " + str(key2add) + "; time: " + time4xi() + "}"
                            # 
                            
                            print4xi(class2print, method2print, message2print)
                            message2print = "{(Step 7R/33) got" + "; line2write-got-by-walk2deldup4app: " + str(line2write) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)
                            # 
                            file2output.write(line2write)
                            
                            previoustag = string2search
                            message2print = "{(Step 7S/33) set" + "; previoustag-got-by-walk2deldup4app to: " + str(previoustag) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)
                            # 
                            
                        else:
                            # 
                            pass    
                    # ---------------------------------------------------------------------------------
                    # READ THE LINES FROM INPUT FILE WITHOUT PROCESSING THEM JATKAA
                    # ---------------------------------------------------------------------------------        
                    for key2pass in keys2pass: 
                        if not line2process:
                            break    
                        line2process = file2input.readline()
                        message2print = "{(Step 7T/33) got" + "; line2process-got-by-walk2deldup4app: " + str(line2process) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        # 
                            
                    
                else:
                    if previoustag == string2search:
                        message2print = "{(Step 8A/33) skipped" + "; previoustag-skipped-by-walk2deldup4app to: " + str(previoustag) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        # <tr>
                    else:    
                        file2output.write(line2process)
                    
                        previoustag = line2process
                        message2print = "{(Step 8B/33) set" + "; previoustag-set-by-walk2deldup4app to: " + str(previoustag) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        # <td>
                        # <b>&Delta;</b> antarcticocean 
                    
        # -----------------------------------------------------------------------------------------
        # (Step 31/33) OF WALK2DELDUP4APP - CLOSE INPUT
        # -----------------------------------------------------------------------------------------            
        file2input.close()
        message2print = "{(Step 31A/33) closed" + "; file2input-closed-by-walk2deldup4app: " + str(file2input) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)           
        # 
            
                        
        # -----------------------------------------------------------------------------------------
        # (Step 32/33) OF WALK2DELDUP4APP - CLOSE OUTPUT
        # -----------------------------------------------------------------------------------------            
        file2output.close()
        message2print = "{(Step 31B/33) closed" + "; file2output-closed-by-walk2deldup4app: " + str(file2output) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        
        previoustag = "<dummy-tag>"    
    else:
        message2print = "{(Step 1E/33) skipped" + "; path2input-skipped-by-walk2deldup4app: " + str(path2input)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                      
        # 
            
        count2skipped = count2skipped + 1
        count2total = count2total + 1
                    
#</function4xi>
    

# =================================================================================================
#<class4xi class = "DirectoryWalker" base = "None" child = "None" synopsis = "a forward iterator that traverses a directory tree" usage = "
#   to review all tests"
#>
# =================================================================================================
class DirectoryWalker:

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "init" usage = "initializes DirectoryWalker"> 
    # ---------------------------------------------------------------------------------------------
    def __init__(self, directory):
        self.stack = [directory]
        self.files = []
        self.index = 0
        
    #</methodize4xi>
            
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "getitem" usage = "getting item"> 
    # ---------------------------------------------------------------------------------------------
    def __getitem__(self, index):
        while 1:
            # ------------------------------------------------------------------------------------- 
            #
            # -------------------------------------------------------------------------------------          
            try:
                # --------------------------------------------------------------------------------- 
                #
                # ---------------------------------------------------------------------------------             
                file = self.files[self.index]
                self.index = self.index + 1
            except IndexError:
                # --------------------------------------------------------------------------------- 
                # pop next directory from stack
                # ---------------------------------------------------------------------------------             
                self.directory = self.stack.pop()
                self.files = os.listdir(self.directory)
                self.index = 0
            else:
                # --------------------------------------------------------------------------------- 
                # got a filename
                # ---------------------------------------------------------------------------------             
                fullname = os.path.join(self.directory, file)
                if os.path.isdir(fullname) and not os.path.islink(fullname):
                    self.stack.append(fullname)
                return fullname
    #</methodize4xi>
#</class4xi>

     
# -------------------------------------------------------------------------------------------------
#<function4xi function = "main" usage = "
#   reviewing all tests
#">                           
# -------------------------------------------------------------------------------------------------
def main():
    global ack2debug
    global count2skipped
    global count2replaced
    global count2total
    
    global header2trace
    
    global kb2stat
    global kb2search
    global keys2stat
    global key2stat
        
    global path2read4xi
    global path2write4xi
    global previoustag
    global profile2fetch

    global t2xi
    global trace_object_count    

       
                       
    # ------------------------------------------------------------------------------------------------- 
    # INITIALIZE
    # -------------------------------------------------------------------------------------------------        
    t2xi = Print4Xi()
    if ack2debug is True:
        print("(Step 0A/33) OF MAIN WALK2DELDUP4APP - SET T2XI TO: ", t2xi)
        # <print4xi.Print4Xi object at 0x0000000003715080> 
    
     
    count2skipped = 0
    count2replaced = 0
    count2total  = 0   

    set2trace4replace()                                                                                               # trace all classes and functions in the system
    deny2trace4replace()                                                                                              # deny trace for all classes and functions in the system
    tailor2trace4xi()                                                                                                 # tailor trace for this test    

    pipe2fetch = Pipe4Xi()
    queue2fetch = Queue4Xi()

    previoustag = "<unknown-tag>"
        
    # --------------------------------------------------------------------------------------------- 
    # START
    # ---------------------------------------------------------------------------------------------        
    print('=' *70)
    print("(Step 0B/33) OF MAIN WALK2DELDUP4APP - VERSION 4.4 FOR ", path2read4xi, " WITH PROFILE: ", profile2fetch, " STARTED ", time4xi())
    #
    
    pipe2fetch = Pipe4Xi()
    if ack2debug is True:
        print("(Step 1A/33) OF MAIN WALK2DELDUP4APP - PIPE2FETCH ", pipe2fetch)    
        # PIPE2FETCH  (<pipeconnection4xi.PipeConnection4Xi object at 0x0000000002F71AC8>, <pipeconnection4xi.PipeConnection4Xi object at 0x0000000002F71B70>)
    queue2fetch = Queue4Xi()
    if ack2debug is True:
        print("(Step 1B/33) OF MAIN WALK2DELDUP4APP - QUEUE2FETCH ", queue2fetch)    
        # QUEUE2FETCH  <queue4xi.Queue4Xi object at 0x0000000002F719B0>
        print("(Step 1C/33) OF MAIN WALK2DELDUP4APP - PATH2READ4XI ", path2read4xi) 
        # PATH2READ4XI  G://temp//job2studio4xi//in//one2do4app//
        print("(Step 1D/33) OF MAIN WALK2DELDUP4APP - PATH2WRITE4XI ", path2write4xi)
        # PATH2WRITE4XI  G://temp//job2studio4xi//out//one2ftp4app//
    
    for file2walk in DirectoryWalker(path2read4xi):
        # ----------------------------------------------------------------------------------------- 
        #
        # -----------------------------------------------------------------------------------------     
        if os.path.isdir(file2walk):
            print("(Step 2A/33) OF MAIN WALK2DELDUP4APP - DIRECTORY: ", file2walk)
            # 
        if os.path.isfile(file2walk):
            walk2deldup4app(file2walk)
            
    # --------------------------------------------------------------------------------------------- 
    # END
    # --------------------------------------------------------------------------------------------- 
    print('=' *75)
    print("(Step 3A/33) OF MAIN WALK2DELDUP4APP - VERSION 4.4 - IN: ", path2read4xi, "- OUT: ", path2write4xi," - PROFILE: ", profile2fetch, " COMPLETED  ", time4xi())
    # IN:  G://temp//job2studio4xi//in//one2do4app// - 
    # OUT:  G://temp//job2studio4xi//out//one2ftp4app//  - 
    # PROFILE:  .html  
    
    # G://temp//job2studio4xi//in//all2do4app// - OUT:  G://temp//job2studio4xi//out//all2ftp4app//  - PROFILE:  .html  COMPLETED   15:18:50 02/05/20 FLE Standard Time
    # <=> all html files are OK i.e. no dublicate  <tr> tags      

       
    # ===========================================================================
    print('=' *75)
    print("(Step 4A/33) OF MAIN WALK2DELDUP4APP  - HEADER2TRACE: ", header2trace, " DOUBLE TAG DELETED: ", kb2search [1] )
    # HEADER2TRACE:  <h3><b>&Psi;</b> Ocean, Desert, Tepui, Environment</h3>  DOUBLE TAG DELETED:  <tr>
    # 
    # 
    for key2stat in keys2stat:
        print("kb2stat[ ", key2stat, "]: ", kb2stat[key2stat])
        # kb2stat[  1 ]:  G://temp//job2studio4xi//in//one2do4app//marlinfishing_app\index.html
        # kb2stat[  2 ]:  G://temp//job2studio4xi//in//one2do4app//marlinfishing_app\index.html
        # kb2stat[  3 ]:  G://temp//job2studio4xi//in//one2do4app//atlanticocean_app\index.html    
    # ---------------------------------------------------------------------------------------------    
    # Print Trace
    # ---------------------------------------------------------------------------------------------     
    # print ('(Step 1E/33) OF MAIN WALK2DELDUP4APP - PRINTING TRACE WITH T2XI', t2xi)
    # 
    # print_trace4xi(t2xi)        
    # print ('(Step 1F/33) OF MAIN WALK2DELDUP4APP - PRINTED TRACE WITH T2XI', t2xi)           
    
#</function4xi>
    
        
# -------------------------------------------------------------------------------------------------
if __name__ == '__main__':
    main()        
#</program4xi>


# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
# >> https://www.dragonxi.com/ 

#"
#>
#     
# 
# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 
#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of walk2deldup4app.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>

